import collection.Seq

object Powerset {

  def emptyTest [A] (s: Seq[A]) : Boolean = s.isEmpty
  
  def powerset [A] (s: Seq[A]) : Seq [Seq [A]] = {
    if (s.isEmpty)
      Seq(s)
    else {
     val p = powerset(s.drop(1));
     p.map(x => s.head +: x) ++ p
    }
  }
  
  def repl_at [A] (s: Seq [Seq [A]], a: A, i : Int) = 
		  s.patch(i, Seq(a +: s(i)), 1)
  
 // construct the set of sets where a is inserted in each element of s
 // example:  stuff(Seq(Seq(1, 2), Seq(3, 4)), 5)
 // gives: List(List(List(1, 2), List(5, 3, 4)), List(List(5, 1, 2), List(3, 4)))
  def stuff [A] (s: Seq [Seq [A]], a: A) : Seq[Seq [Seq [A]]] = {
    var r : Seq[Seq [Seq [A]]] = Seq()
    for(i <- (0 until (s.length))) {
      r = repl_at (s, a, i) +: r
    }
    r
  }
 
  // Partition s in k non-empty subsets
  def k_partition [A] (s: Seq[A], k:Int) : Seq[Seq [Seq [A]]] = {
    
    if (s.isEmpty && k == 0)
      Seq(Seq())
    else if (s.isEmpty || k == 0)
      Seq()
    else {
    	  val p1 = k_partition (s.drop(1), k-1);
    	  val p2 = k_partition (s.drop(1), k);
    	  p1.map(x => Seq(s.head) +: x) ++
    	  p2.flatMap(x => stuff(x, s.head))
      }
  }
  
}