import collection.Seq


object RelationSeq {
  
  def elem_prod [A] (xs: Seq[(A,A)]) (y: (A,A)) : Seq[(A,A)] = 
    xs flatMap (x => if (x._2 == y._1) Seq((x._1, y._2)) else Seq())

// remove duplicates
  def rel_prod [A] (xs: Seq[(A,A)]) (ys: Seq[(A,A)]) : Seq[(A,A)] = {
    (xs flatMap (elem_prod(ys))).distinct
  }
  
  def subsetof [A] (xs: Seq[A], ys: Seq[A]) : Boolean = 
    xs forall (x => ys contains x)
    
  def lfp [A] (f: Seq[A] => Seq[A], xs: Seq[A]) : Seq [A] = {
    if (subsetof (f(xs), xs))
      xs
    else lfp (f, f(xs))
  }
  
  def transclos [A] (xs: Seq[(A,A)]) : Seq[(A,A)] = 
    lfp ((ys: Seq[(A,A)]) => (ys union rel_prod(ys)(xs)).distinct, xs)
    
  def foo (xs: Seq[Int]) : Map [Int, Seq[Int]] = {
    xs groupBy (x => x % 2)
  }
 
}